-- altera vhdl_input_version vhdl_2008
-- XXX: QSYS Fix (https://www.intel.com/content/www/us/en/support/programmable/articles/000079458.html)

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.math_pkg.all;
use work.rtps_package.all;
use work.user_config.all;
use work.rtps_config_package.all;

entity rtps_reader_syn is
    port (
        -- SYSTEM
        clk                 : in std_logic;
        reset               : in std_logic;
        time                : in TIME_TYPE;
        -- FROM RTPS HANDLER (USER TRAFFIC)
        empty_user          : in std_logic_vector(0 to 0);
        rd_user             : out std_logic;
        data_in_user        : in std_logic_vector(WORD_WIDTH-1 downto 0);
        last_word_in_user   : in std_logic;
        -- FROM RTPS BUILTIN ENDPOINT (META TRAFFIC)
        empty_meta          : in std_logic_vector(0 to 0);
        rd_meta             : out std_logic;
        data_in_meta        : in std_logic_vector(WORD_WIDTH-1 downto 0);
        last_word_in_meta   : in std_logic;
        -- RTPS OUTPUT
        full_ro             : in std_logic;
        wr_ro               : out std_logic;
        data_out_ro         : out std_logic_vector(WORD_WIDTH-1 downto 0);
        last_word_out_ro    : out std_logic;
        -- TO HISTORY CACHE
        start_hc            : out std_logic_vector(0 to 0);
        opcode_hc           : out HISTORY_CACHE_OPCODE_ARRAY_TYPE(0 to 0);
        ack_hc              : in std_logic_vector(0 to 0);
        done_hc             : in std_logic_vector(0 to 0);
        ret_hc              : in HISTORY_CACHE_RESPONSE_ARRAY_TYPE(0 to 0);
        valid_out_hc        : out std_logic_vector(0 to 0);
        ready_out_hc        : in std_logic_vector(0 to 0);
        data_out_hc         : out WORD_ARRAY_TYPE(0 to 0);
        last_word_out_hc    : out std_logic_vector(0 to 0)
    );
end entity;

architecture arch of rtps_reader_syn is
begin
    
    if_gen : if (NUM_READERS > 0) generate
        syn_inst : entity work.rtps_reader(arch)
            generic map (
                NUM_READERS     => 1,
                CONFIG_ARRAY    => to_QUARTUS_CONFIG_ARRAY_TYPE(ENDPOINT_CONFIG(0 to 0)),
                ENTITYID        => ENTITYID(0 to 0)
            )
            port map (
                clk                 => clk,
                reset               => reset,
                time                => time,
                empty_user          => empty_user,
                rd_user             => rd_user,
                data_in_user        => data_in_user,
                last_word_in_user   => last_word_in_user,
                empty_meta          => empty_meta,
                rd_meta             => rd_meta,
                data_in_meta        => data_in_meta,
                last_word_in_meta   => last_word_in_meta,
                full_ro             => full_ro,
                wr_ro               => wr_ro,
                data_out_ro         => data_out_ro,
                last_word_out_ro    => last_word_out_ro,
                start_hc            => start_hc,
                opcode_hc           => opcode_hc,
                ack_hc              => ack_hc,
                done_hc             => done_hc,
                ret_hc              => ret_hc,
                data_out_hc         => data_out_hc,
                valid_out_hc        => valid_out_hc,
                ready_out_hc        => ready_out_hc,
                last_word_out_hc    => last_word_out_hc
            );
    end generate;

end architecture;
